zoukankan      html  css  js  c++  java
  • LeetCode -- Two Sum

    Question:

        Given an array of integers, find two numbers such that they add up to a specific target number.

    The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

    You may assume that each input would have exactly one solution.

    Input: numbers={2, 7, 11, 15}, target=9
    Output: index1=1, index2=2

    Analysis:

    O(n2) runtime, O(1) space – Brute force:

    The brute force approach is simple. Loop through each element x and find if there is another value that equals to target – x. As finding another value requires looping through the rest of array, its runtime complexity is O(n2).

    用暴力求解方法,时间复杂度较高,两次for循环,但方法容易想到。

    O(n) runtime, O(n) space – Hash table:

    We could reduce the runtime complexity of looking up a value to O(1) using a hash map that maps a value to its index.

    用HashMap记录遍历过的数字所需要的val,然后返回index即可,时间复杂度小。

    Answer:

    1. 暴力求解:

    public class Solution {
        public int[] twoSum(int[] nums, int target) {
            int[] res = new int[2];
            
            for(int i=0; i<nums.length; i++) {
                for(int j=i+1; j<nums.length; j++) {
                    int sum = nums[i] + nums[j];
                    if(sum == target) {
                        res[0] = i + 1;
                        res[1] = j + 1;
                        break;
                    }
                }
            }
            return res;
        }
    }

    2. HashMap巧解。

    public class Solution {
        public int[] twoSum(int[] nums, int target) {
            
            int[] res = new int[2];
            
            HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();
            for(int i=0; i<nums.length; i++) {
                if(map.containsKey(nums[i])) {
                    res[0] = map.get(nums[i]) + 1;
                    res[1] = i + 1;
                }
                else {
                    map.put(target - nums[i], i);
                }
            }
            
            
            return res;
        }
    }
  • 相关阅读:
    ThreadLocal
    spring概述
    排序
    内存的分配原则
    常用概念比较
    垃圾回收机制
    java的内存模型
    对象的内存布局
    adb connect 和 install 通讯流程
    Android硬件抽象层(HAL)深入剖析(三)
  • 原文地址:https://www.cnblogs.com/little-YTMM/p/4786233.html
Copyright © 2011-2022 走看看